

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.Notify.Enums
    ( 

 -- * Enumerations
-- ** Urgency #enum:Urgency#

    Urgency(..)                             ,




    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL


-- Enum Urgency
{- |
The urgency level of the notification.
-}
data Urgency = 
      UrgencyLow
    {- ^
    Low urgency. Used for unimportant notifications.
    -}
    | UrgencyNormal
    {- ^
    Normal urgency. Used for most standard notifications.
    -}
    | UrgencyCritical
    {- ^
    Critical urgency. Used for very important notifications.
    -}
    | AnotherUrgency Int
    -- ^ Catch-all for unknown values
    deriving (Show, Eq)

instance P.Enum Urgency where
    fromEnum UrgencyLow = 0
    fromEnum UrgencyNormal = 1
    fromEnum UrgencyCritical = 2
    fromEnum (AnotherUrgency k) = k

    toEnum 0 = UrgencyLow
    toEnum 1 = UrgencyNormal
    toEnum 2 = UrgencyCritical
    toEnum k = AnotherUrgency k

instance P.Ord Urgency where
    compare a b = P.compare (P.fromEnum a) (P.fromEnum b)

foreign import ccall "notify_urgency_get_type" c_notify_urgency_get_type :: 
    IO GType

instance BoxedEnum Urgency where
    boxedEnumType _ = c_notify_urgency_get_type


